
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Deque;
import java.util.LinkedList;
import java.util.StringTokenizer;

public class Task7
{
	public static void main(String[] args) throws IOException
	{
		// načítání
		System.setIn(Files.newInputStream(Paths.get("graph.txt")));
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
//		System.setOut(new PrintStream(Files.newOutputStream(Paths.get("task7.out"))));
		
		StringTokenizer st = new StringTokenizer(br.readLine());
		final int N = Integer.parseInt(st.nextToken());
		final int M = Integer.parseInt(st.nextToken());
		
		// adjacency list
		final IntList[] adj = new IntList[N];
		for(int i = 0; i < N; i++)
			adj[i] = new IntList();
		
		// read the graph
		for(int i = 0; i < M; i++)
		{
			st = new StringTokenizer(br.readLine());
			final int src = Integer.parseInt(st.nextToken());
			final int target = Integer.parseInt(st.nextToken());
			adj[src].add(target);
			adj[target].add(src);
		}
		
		// solve the task
		bfs(0, adj);
	}
	
	public static void bfs(int src, IntList[] adj) {
		boolean[] visited = new boolean[adj.length];
		visited[src] = true;
		System.out.println(Integer.toString(src));
		Deque<Integer> deq = new LinkedList<>();
		deq.add(src);
		int count = 1;
		
		while(!deq.isEmpty()) {
			final int v = deq.removeFirst();
			for(Integer w : adj[v])
				if(!visited[w])
				{
					visited[w] = true;
					System.out.println(Integer.toString(w));
					deq.addLast(w);
					count++;
				}
		}
		
		System.out.println(count + " vertices total");
	}
}

class IntList extends ArrayList<Integer> {}